(********************************************************)
(*   Olivier Boite (under supervision C. Dubois) - 2001 *)
(*   Catherine Dubois - translation to V8 - sept. 2012  *)
(********************************************************)
  
Require Import Language_spec.
Require Import Small_step_spec.
Require Import Typing_spec.

Lemma is_value_dec : forall e : expr, {is_value e} + {~ is_value e}.
intros.
induction e
 as
  [c|
   i|
   l|
   i e Hrece|
   e1 Hrece1 e0 Hrece0|
   i e1 Hrece1 e0 Hrece0|
   e1 Hrece1 e0 Hrece0 e2 Hrece2|
   e1 Hrece1 e0 Hrece0|
   e Hrece|
   e Hrece|
   e1 Hrece1 e0 Hrece0|
   e1 Hrece1 e0 Hrece0].
left; apply Cst_val.
right; intro Hvar; inversion Hvar.
left; apply Loc_val.
left; apply Fun_val.
right; intro Happ; inversion Happ.
right; intro Hlet; inversion Hlet.
right; intro Hif; inversion Hif.
right; intro Hwhile; inversion Hwhile.
right; intro Hlet; inversion Hlet.
right; intro Hderef; inversion Hderef.
right; intro Hsequ; inversion Hsequ.
right; intro Hass; inversion Hass.
Qed.
 


Lemma bool_dec :
 forall (e : expr) (env : env_typ),
 type_of env e (Const_t Bool) -> is_value e -> {e = vrai} + {e = faux}.
intros e env Htyp Hval.
induction e
 as
  [c|
   i|
   l|
   i e Hrece|
   e1 Hrece1 e0 Hrece0|
   i e1 Hrece1 e0 Hrece0|
   e1 Hrece1 e0 Hrece0 e2 Hrece2|
   e1 Hrece1 e0 Hrece0|
   e Hrece|
   e Hrece|
   e1 Hrece1 e0 Hrece0|
   e1 Hrece1 e0 Hrece0].
induction c as [n| b| ].
left; inversion Htyp.
induction b.
left; trivial.
right; trivial.
left; inversion Htyp.
left; inversion Hval.
left; inversion Htyp.
left; inversion Htyp.
left; inversion Hval.
left; inversion Hval.
left; inversion Hval.
left; inversion Hval.
left; inversion Hval.
left; inversion Hval.
left; inversion Hval.
left; inversion Hval.
Qed.